(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2009-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uindex_index.ml,v 1.5 2014-01-21 17:17:21 fclement Exp $*)

(* The type of index indices. *)

type 'a element = 'a Uindex.t;;
type 'a index = 'a element Uindex.t;;

let to_index = Uindex.to_t
and of_index = Uindex.of_t
;;

let of_natural = Uindex.of_natural
and to_natural = Uindex.to_natural
;;

let of_int = Uindex.of_int
and to_int = Uindex.to_int
;;

let _0_ = Uindex._0_
and _1_ = Uindex._1_
;;

let succ = Uindex.succ
and pred = Uindex.pred
;;
