(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 3.3+dev4 generated code *)

let print_aref pp_a ppf = function
  | { Uaref.get = f_u_a; Uaref.set = f_a_u; } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>get =@ ";
    Lib_print.print_fun Lib_print.print_unit pp_a ppf f_u_a;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>set =@ ";
    Lib_print.print_fun pp_a Lib_print.print_unit ppf f_a_u;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

let print_t pp_a ppf = function | a_a -> print_aref pp_a ppf a_a
;;

let print_aref_list pp_a ppf = function
  | {
      Uaref.get_list = f_u_a_l;
      Uaref.clear_list = f_u_u;
      Uaref.add_item = f_a_u;
    } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Format.fprintf ppf "%,@[<1>get_list =@ ";
    Lib_print.print_fun Lib_print.print_unit (Lib_print.print_List pp_a) ppf
     f_u_a_l;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>clear_list =@ ";
    Lib_print.print_fun Lib_print.print_unit Lib_print.print_unit ppf f_u_u;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>add_item =@ ";
    Lib_print.print_fun pp_a Lib_print.print_unit ppf f_a_u;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

let print_aref_name ppf = function | s -> Lib_print.print_quoted_string ppf s
;;

let print_aref_spec _pp_a _pp_b ppf = function
  | a -> Lib_print.print_abstract ppf a
;;

let print_bounds_spec pp_b ppf = function
  | {
      Uaref.min = b_o;
      Uaref.max = b_o0;
      Uaref.compare = f_b_f_b_i;
      Uaref.string_of = f_b_s;
    } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>min =@ ";
    Lib_print.print_Option pp_b ppf b_o; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>max =@ ";
    Lib_print.print_Option pp_b ppf b_o0; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>compare =@ ";
    Lib_print.print_fun pp_b
     (Lib_print.print_fun pp_b Lib_print.print_quoted_int) ppf f_b_f_b_i;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>string_of =@ ";
    Lib_print.print_fun pp_b Lib_print.print_quoted_string ppf f_b_s;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

let print_flag ppf = function
  | {
      Uaref.get_flag = f_u_b;
      Uaref.set_flag = f_u_u;
      Uaref.unset_flag = f_u_u0;
    } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Format.fprintf ppf "%,@[<1>get_flag =@ ";
    Lib_print.print_fun Lib_print.print_unit Lib_print.print_bool ppf f_u_b;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>set_flag =@ ";
    Lib_print.print_fun Lib_print.print_unit Lib_print.print_unit ppf f_u_u;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>unset_flag =@ ";
    Lib_print.print_fun Lib_print.print_unit Lib_print.print_unit ppf f_u_u0;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

let print_tflag ppf = function
  | { Uaref.get_tflag = f_u_b; Uaref.toggle_tflag = f_u_u; } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Format.fprintf ppf "%,@[<1>get_tflag =@ ";
    Lib_print.print_fun Lib_print.print_unit Lib_print.print_bool ppf f_u_b;
    Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>toggle_tflag =@ ";
    Lib_print.print_fun Lib_print.print_unit Lib_print.print_unit ppf f_u_u;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

(* End of OCamlGen, 3.3+dev4 generated code *)
