(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 3.3+dev4 generated code *)

let print_index ppf = function | u_i -> Upervasives_print.print_index ppf u_i
;;

let print_offset ppf = function | u_t -> Unatural_print.print_t ppf u_t

and print_length ppf = function
  | u_l -> Upervasives_print.print_length ppf u_l
;;

let print_range ppf = function
  | { Usubarray_types.offset = o; Usubarray_types.length = l; } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>offset =@ ";
    print_offset ppf o; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>length =@ "; print_length ppf l;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

let print_indices ppf = function
  | Usubarray_types.Range r ->
    Format.fprintf ppf "@[<1>%s@ " "Range"; print_range ppf r;
    Format.fprintf ppf "%,@]"
  | Usubarray_types.Indices i_a ->
    Format.fprintf ppf "@[<1>%s@ " "Indices";
    Lib_print.print_Array print_index ppf i_a; Format.fprintf ppf "%,@]"
;;

let print_t pp_a ppf = function
  | { Usubarray_types.support = a_a; Usubarray_types.indices = i; } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>support =@ ";
    Lib_print.print_Array pp_a ppf a_a; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>indices =@ "; print_indices ppf i;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

(* End of OCamlGen, 3.3+dev4 generated code *)
