(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2009-2013 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: patchwork.mli,v 1.1 2013/06/13 19:01:17 fclement Exp $ *)

open Patchwork_types;;

(*
val digest : ('a, 'a t) Utype_digest.lifter;;
val location_digest : ('a, 'a location) Utype_digest.lifter;;
*)

val top : 'a t -> 'a location;;

val zip : 'a location -> 'a t;;
val unzip : 'b location -> 'a t -> 'a location;;

val fold_left :
  ('accu -> 'a location -> 'a -> 'accu) -> 'accu -> 'a t -> 'accu
;;

val map : ('a -> 'b) -> 'a t -> 'b t;;

val push_piece_in_patch : 'a t -> 'a -> 'a t;;

val pop_piece_in_patch : 'a t -> 'a t;;

val has_head_piece_in_patch : 'a t -> bool;;

val head_piece_in_patch : 'a t -> 'a;;

val replace_head_piece_in_patch : 'a -> 'a t -> 'a t;;

val replace_head_piece_in_patch_with_pieces : 'a list -> 'a t -> 'a t;;
